/* 

QRG is stored in an uint32_t as QRG*100
highest uint32_t is   4,294,967,295
*100Hz              429,496,729,500     theoretical limit roughly 429GHz
so highest QRG is     9,999,999,900     GMMMkkkH (only one digit for GHz, no 10/1Hz) 
lowest resolution is            100 Hz  because 10Hz and 1Hz are not interpreted 

short description (german)
Mit Links/Rechts kann durch die einzelnen Ausgänge gescrollt werden. 
Geht das Funkgerät auf Senden (PTT wird low) - ist das umschalten aus Sicherheitsgründen gesperrt.
Die gewählte Antenne wird für jedes Band separat gespeichert. Dies erfolgt automatisch nach einer Verzögerung von einigen Sekunden.
Die aktuelle Frequenz (QRG) wird ausgelesen
Ändert sich QRG, wird diese am LCD angezeigt und ermittet ob sich dadurch das Band geändert hat. 
Bei einer Bandänderung wird auf die definierte Antenne umgechaltet. 
Wird eine Frequenz außerhalb eines definierten Bandes angewählt, so wird die Antenne NICHT geändert

einige Goodies der vorliegenden Version
Bei CAT Aktivität wird dies (wie im Sketch von ON7EQ)
Werden Werte im EEPROM gespeicher wird dies kurz angezeigt (wie im Sketch von ON7EQ)
Wird längere Zeit keine QRG empfangen erscheint ein offline Indikator

einige Änderungen gegenüber Sketch ON7EQ
Der Sketch kompiliert mit einer aktuelleren Arduino IDE (z.B. mit 1.8.19 und 2.1.0)
Die Variablen lauten ähnlich wie bei ON7EQ, ein Umstieg soll leicht fällt
Der Auswertungsteil wurde von Santos übernommen
Die Programmlogik verzichtet auf GOTO
Als Schnittstelle kann wahlweise Soft-Serial (für den UNO), oder eine HW-Serial (für den MEGA) verwendt werden
Das LCD bietet mehrere Schnittstellen an, standard ist zwar I2C, aber man kann mit der gleichen Libary auch parallel verbinden oder ein RGB LCD anschließen

Die Ausgangsanzahl ist nur durch die verfügbaren Pins beschränkt. 
Ein UNO hat 13 Digital pins und 5 Analogpins
benötigt werden bis zu 3 Usertasten
ein PTT Eingang
zwei für das I2C Display
die zwei 2 HW-Serial/USB belege ich nie
und für die Kommunikation zum Funkgerät sperre ich auch 2 Pins

23-10 = 10 freie Pins. Ein Variante mit 8 Pins habe ich selber gebaut.

Some Program internal comments:
class and function naming convention:

noun describing the main actor 
Verb the activity to be be done
[Noun] the object to be changed by the actor

Further links to read:

https://de.wikipedia.org/wiki/CAT_(Amateurfunk): CAT steht als Abkürzung für Computer Aided Transceiver (selten auch für Computer Aided Tuning), und beschreibt das Verfahren, einen Sendeempfänger (englisch Transceiver) oder auch nur einen Empfänger mithilfe eines PCs (Personal Computer oder Notebook) fernzusteuern. Die Abkürzung CAT hat sich insbesondere im Amateurfunk eingebürgert. 

https://maxpromer.github.io/LCD-Character-Creator/  generate custom chars: 
https://www.qsl.net/on7eq/projects/arduino_ant_matrix.htm   The original sketch from ON7EQ: 
https://dxham.de/?p=1122   German build.
https://dxham.de/wp-content/uploads/2016/02/ant_switsch-e1456350019703.jpg Circuit


*******************
ICOM CI-V specific:
*******************
Example telegrams:
FEFE00040060530994FD
FEFE00040060530150FD
FEFE00040060530114FD
FEFE00580000350507FD
FEFE00040060529124FD
FEFE00040060520128FD
FEFE00040060523121FD
FEFE00040060511121FD
FEFE00040060515503FD
FEFE00040060514700FD
FEFE00040060517801FD
FEFE00040060518801FD
FEFE006A000050284501FD  145.285

FEFE0058000020243204FD  432.242
FEFE                    start marker
    00                  to
      04                from
        00              command
          00            10Hz & 1Hz
            20          1Khz & 100Hz
              24        100Khz & 10KHz
                32      10Mhz & 1Mhz
                  04    1GHz & 100Mhz (optional)
                    FD  end marker

Further examples taken from an I
FE FE 00 94 00 30 40 16 07 00 FD 
FE FE 00 94 00 30 39 16 07 00 FD 
FE FE 00 94 00 20 38 16 07 00 FD 
FE FE 00 94 00 40 36 16 07 00 FD 
FE FE 00 94 00 20 36 16 07 00 FD 

FE FE 94 E0 03 FD                    Request from amplifier after PTT (03 = Read operating frequency)
FE FE E0 94 03 80 41 16 07 00 FD     response from transmitter to amplifier

FE FE 94 E0 03 FD 
FE FE E0 94 03 90 31 16 07 00 FD 

You must use a Serial Programm and send HEX values.
The Serial Monitor of Arduino IDE ist not able to send HEX.

*******************
YAESU RS232 specific:
*******************
YAESU is using serval protocols. This implementation is done for a YAESU FTDX101MP

*******************
YAESU Linear 15pin socket
*******************
This reads the binary code from 4 pins on the "Linear 15pin socket" to gather the band information

 */
